# Coveo FacetValueSuggestions Component (CoveoFacetValueSuggestions)

This component provides `Omnibox` query suggestions scoped to distinct categories based on the values of a specific `field` whose Facet option is enabled.

Available since

  May 2018 Release (v2.4094.8)

Additional documentation

  Providing Facet Value Suggestions

## Index

### Methods

- debugInfo
- disable
- enable
- getBindings
- get

### Properties

- bind
- componentOptionsModel
- componentStateModel
- disabled
- logger
- queryController
- queryStateModel
- root
- searchInterface
- ID

### Accessors

- usageAnalytics

### Component Options

- categoryFieldDelimitingCharacter
- displayEstimateNumberOfResults
- expression
- field
- isCategoryField
- numberOfSuggestions
- templateHelper
- useQuerySuggestions
- useValueFromSearchbox

### Constructors

- constructor

## Methods

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  Return the debug info about this component.

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  Disable the component. Normally this means that the component will not execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  Enable the component. Normally this means that the component will execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts :328

  Return the bindings, or environment, for the current component.

  #### Returns IComponentBindings

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts :410

  Get the bound component to the given HTMLElement. Throws an assert if the HTMLElement has no component bound, unless using the noThrow argument.
  If there is multiple component bound to the current HTMLElement, you must specify the component class.

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement for which to get the bound component.

  - ##### Optional componentClass: any

    Optional component class. If the HTMLElement has multiple components bound, you must specify which one you are targeting.

  - ##### Optional noThrow: boolean

    Boolean option to tell the method to not throw on error.

  #### Returns BaseComponent

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts :270

Allows the component to bind events and execute them only when it is enabled.

type

  {Coveo.ComponentEvents}

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts :294

Contains the state of options for different components. Mainly used by ResultLink.

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts :282

Contains the state of different components (enabled vs disabled). Allows to get/set values. Triggers component state event when modified. Each component can listen to those events.

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

A disabled component will not participate in the query, or listen to ComponentEvents.

type

  {boolean}

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

Allows component to log in the dev console.

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts :286

Contains the singleton that allows to trigger queries.

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts :278

Contains the state of the query. Allows to get/set values. Trigger query state event when modified. Each component can listen to those events.

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts :274

A reference to the root HTMLElement (the SearchInterface).

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts :290

A reference to the root of every component, the SearchInterface.

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

The static ID that each component needs in order to be identified.
For example, SearchButton -> static ID: SearchButton -> className: CoveoSearchButton

## Accessors

### usageAnalytics

- get (): IAnalyticsClient

- Inherited from Component.usageAnalytics

  - Defined in ui/Base/Component.ts :343

  A reference to the Analytics.client.

  #### Returns IAnalyticsClient

## Component Options

### categoryFieldDelimitingCharacter

categoryFieldDelimitingCharacter: string

- Defined in ui/FacetValueSuggestions/FacetValueSuggestions.ts :137

The delimiting character used for the multi-value field referenced by the `field` option.

Only effective when

  `isCategoryField` is truthy

Default

  `|`

Markup configuration example(s) :

    data-category-field-delimiting-character=';'
    data-category-field-delimiting-character='#'

### displayEstimateNumberOfResults

displayEstimateNumberOfResults: boolean

- Defined in ui/FacetValueSuggestions/FacetValueSuggestions.ts :96

Whether to display an estimate of the number of results for each scoped query suggestions.

Notes:

- Setting this option to `true` has no effect when the `templateHelper` options is set.
- When displaying scoped query suggestions for a standalone search box whose queries are redirected to a search interface enforcing other filters, the number of results will be inaccurate.

Default

  `false`

Markup configuration example(s) :

    data-display-estimate-number-of-results='true'
    data-display-estimate-number-of-results='false'

### expression

expression: string

- Defined in ui/FacetValueSuggestions/FacetValueSuggestions.ts :146

An advanced query expression to add when requesting facet value suggestions.

Set this option to ensure that the suggestions are properly scoped when using the component with a standalone search box. For instance, if a certain tab is automatically selected in the search interface the standalone search box is redirecting its queries to, you should set this option to that tab's `expression`.

Markup configuration example(s) :

    data-expression='@objecttype==Message'

### field

field: IFieldOption

- Defined in ui/FacetValueSuggestions/FacetValueSuggestions.ts :62

The field on whose values the scoped query suggestions should be based.

Required

  Specifying a value for this option is required for the component to work

Markup configuration example(s) :

    data-field='@productcategory'

### isCategoryField

isCategoryField: boolean

- Defined in ui/FacetValueSuggestions/FacetValueSuggestions.ts :130

Whether the `field` option references a multi-value field.

Setting this option to `true` if appropriate will allow the corresponding `CategoryFacet` or `DynamicHierarchicalFacet` component (if present) to properly handle the filter format.

See also the `categoryFieldDelimitingCharacter` option.

Default

  `false`

Markup configuration example(s) :

    data-is-category-field='true'
    data-is-category-field='false'

### numberOfSuggestions

numberOfSuggestions: number

- Defined in ui/FacetValueSuggestions/FacetValueSuggestions.ts :67

The maximum number of suggestions to render in the `Omnibox`.

Minimum

  `1`

Default

  `5`

Markup configuration example(s) :

    data-number-of-suggestions='10'

### templateHelper

templateHelper: function

- Defined in ui/FacetValueSuggestions/FacetValueSuggestions.ts :119

The template helper function to execute when rendering each scoped query suggestion.

If specified, the function must have the following signature: (row: IFacetValueSuggestionRow, omnibox: Omnibox) => string

If not specified, a default function will be used.

Note: You cannot set this option directly in the component markup as an HTML attribute. You must either set it:

- In the `init` call of your search interface (see Passing Component Options in the init Call
- Before the `init` call, using the `options` top-level function (see Passing Component Options Before the init Call).

Example:

    Coveo.init(document.getElementById('search'), {
      FacetValueSuggestions: {
        templateHelper: (row, omnibox) => { return `Searching for <strong>${row.keyword}</strong> in category <em>${row.value}</em>`; }
      }
    })

#### Type declaration

- - (row: IFacetValueSuggestionRow, omnibox: Omnibox): string

  - #### Parameters

    - ##### row: IFacetValueSuggestionRow

    - ##### omnibox: Omnibox

    #### Returns string

### useQuerySuggestions

useQuerySuggestions: boolean

- Defined in ui/FacetValueSuggestions/FacetValueSuggestions.ts :76

Whether to get scoped query suggestions from the current Coveo ML query suggestions.

Notes:

- If this option is set to `true`, the `enableQuerySuggestAddon` option of the `Omnibox` component must be set to `true` as well.
- If this option is set to `true`, an additional `POST` HTTP request is sent to `https://platform.cloud.coveo.com/rest/search/v2/querySuggest`.

Default

  `true`

Markup configuration example(s) :

    data-use-query-suggestions='true'
    data-use-query-suggestions='false'

### useValueFromSearchbox

useValueFromSearchbox: boolean

- Defined in ui/FacetValueSuggestions/FacetValueSuggestions.ts :83

Whether to get scoped query suggestions from the current user query entered in the search box.

Default: `true` if `useQuerySuggestions` is `false`; `false` otherwise

Markup configuration example(s) :

    data-use-value-from-searchbox='true'
    data-use-value-from-searchbox='false'

## Constructors

### constructor

- new FacetValueSuggestions(element: HTMLElement, options: IFacetValueSuggestionsOptions, bindings?: IComponentBindings): FacetValueSuggestions

- Overwrites Component.constructor

  - Defined in ui/FacetValueSuggestions/FacetValueSuggestions.ts :171

  Creates a new `FacetValueSuggestions` component.

  #### Parameters

  - ##### element: HTMLElement

    The HTMLElement on which to instantiate the component.

  - ##### options: IFacetValueSuggestionsOptions

    The options for the `FacetValueSuggestions` component.

  - ##### Optional bindings: IComponentBindings

    The bindings that the component requires to function normally. If not set, these will be automatically resolved (with a slower execution time).

  #### Returns FacetValueSuggestions